package com.jcg.java8;

import java.time.LocalDateTime;
import java.util.concurrent.CompletableFuture;
import java.util.concurrent.ExecutionException;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;

import org.junit.jupiter.api.Assertions;
import org.junit.jupiter.api.Test;

// CompletableFuture.thenAccept() takes a Consumer<T> and returns CompletableFuture<Void>.

class DemoTest {

	@Test
	void test_thenAcceptDemo() throws ExecutionException, InterruptedException {
		CompletableFuture<Void> c =
				CompletableFuture.supplyAsync(LocalDateTime::now)
				.thenAccept(event -> {
					System.out.println("Event is at = " + event);
				});

		Assertions.assertNull(c.get());
	}

	@Test
	void test_thenAcceptDemo1() throws ExecutionException, InterruptedException {
		CompletableFuture<Void> c =
				CompletableFuture.supplyAsync(LocalDateTime::now)
				.thenApplyAsync(event -> "Current time is " + event)
				.thenAccept(message -> {
					System.out.println("Hello James. " + message);
				});

		Assertions.assertNull(c.get());
	}

	@Test
	void test_thenAcceptDemo2() throws ExecutionException, InterruptedException {
		final ExecutorService pool = Executors.newFixedThreadPool(2);

		CompletableFuture<Void> c =
				CompletableFuture.supplyAsync(() -> "JavaCodeGeeks", pool)
				.thenAccept(message -> {
					System.out.println("Welcome " + message + ".");
				});

		Assertions.assertNull(c.get());

		pool.shutdown();
	}
}
